//EspaceEntreDeuxBlocs_501f.js
// 19.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Indique l'espace horizontal et vertical entre deux blocs.

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester, s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

var curDoc = app.documents[0];

// mmoriser la slection
var curSel = app.selection;

// tester, si deux blocs sont slectionns
if (curSel.length == 0) {
	alert ("Il faut slectionner deux blocs.", "Attention");
	exit();
}
else if (curSel.length == 1) {
	alert ("Slectionner un *second* bloc.", "Attention");
	exit();
}
else if (curSel.length > 2) {
	alert ("Il ne faut slectionner *que deux* blocs.", "Attention");
	exit();
}

// mmoriser les units de mesure
// si ce n'est pas 2053991795 (= millimtres), modifier  millimtres
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// mmoriser l'origine de la rgle, la modifier (si ncessaire)
var rO = curDoc.viewPreferences.rulerOrigin;
if (rO != 1380143983) {
	curDoc.viewPreferences.properties = {rulerOrigin:RulerOrigin.spreadOrigin};
}

// mmoriser les bords de la slection
var gA = curSel[0].geometricBounds;
var gB = curSel[1].geometricBounds;
var vA = curSel[0].visibleBounds;
var vB = curSel[1].visibleBounds;
var hgDiff, vgDiff, hvDiff, vvDiff;

// calculer les valeurs horizontales
if ((gA[1] - gB[1]) > 0) {
	hgDiff = gA[1] - gB[3];
}
else {
	hgDiff = gB[1] - gA[3];
}
hgDiff = (Math.floor((hgDiff*1000)+0.5))/1000;

if ((vA[1] - vB[1]) > 0) {
	hvDiff = vA[1] - vB[3];
}
else {
	hvDiff = vB[1] - vA[3];
}
hvDiff = (Math.floor((hvDiff*1000)+0.5))/1000;

// calculer les valeurs verticales
if ((gA[0] - gB[0]) > 0) {
	vgDiff = gA[0] - gB[2];
}
else {
	vgDiff = gB[0] - gA[2];
}
vgDiff = (Math.floor((vgDiff*1000)+0.5))/1000;

if ((vA[0] - vB[0]) > 0) {
	vvDiff = vA[0] - vB[2];
}
else {
	vvDiff = vB[0] - vA[2];
}
vvDiff = (Math.floor((vvDiff*1000)+0.5))/1000;

// afficher le rsultat
alert ("-----------------------------------\nEspaces gometriques =\n\nhorizontalement  " + hgDiff + " mm\n\nverticalement      " 
+ vgDiff + " mm\n\n-----------------------------------\nEspaces visibles =\n\nhorizontalement  " 
+ hvDiff + " mm\n\nverticalement      " + vvDiff + " mm", " ");

// restaurer les units de mesure (si ncessaire)
function reStore() {
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
}

// rtablir l'origine de la rgle (si ncessaire)
if (rO != 1380143983) {
	curDoc.viewPreferences.rulerOrigin = rO;
}